package cn.iocoder.yudao.module.shop.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.iocoder.yudao.util.DateUtils;
import cn.iocoder.yudao.module.shop.entity.ShopCouponTemplate;
import cn.iocoder.yudao.module.shop.mapper.ShopCouponTemplateMapper;
import cn.iocoder.yudao.module.shop.service.IShopCouponTemplateService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 优惠券模板Service业务层处理
 *
 * @author ruoyi
 * @date 2023-08-29
 */
@Service
public class ShopCouponTemplateServiceImpl extends ServiceImpl<ShopCouponTemplateMapper,ShopCouponTemplate> implements IShopCouponTemplateService
{


    /**
     * 查询优惠券模板
     *
     * @param id 优惠券模板主键
     * @return 优惠券模板
     */
    @Override
    public ShopCouponTemplate selectShopCouponTemplateById(Long id)
    {
        return baseMapper.selectShopCouponTemplateById(id);
    }

    /**
     * 查询优惠券模板列表
     *
     * @param shopCouponTemplate 优惠券模板
     * @return 优惠券模板
     */
    @Override
    public IPage<ShopCouponTemplate> selectShopCouponTemplateList(Page<ShopCouponTemplate> page,ShopCouponTemplate shopCouponTemplate)
    {
        return baseMapper.selectShopCouponTemplateList(page,shopCouponTemplate);
    }

    /**
     * 新增优惠券模板
     *
     * @param shopCouponTemplate 优惠券模板
     * @return 结果
     */
    @Override
    public int insertShopCouponTemplate(ShopCouponTemplate shopCouponTemplate)
    {
        return baseMapper.insertShopCouponTemplate(shopCouponTemplate);
    }

    /**
     * 修改优惠券模板
     *
     * @param shopCouponTemplate 优惠券模板
     * @return 结果
     */
    @Override
    public int updateShopCouponTemplate(ShopCouponTemplate shopCouponTemplate)
    {
        shopCouponTemplate.setUpdateTime(DateUtils.getNowDate());
        return baseMapper.updateShopCouponTemplate(shopCouponTemplate);
    }

    /**
     * 批量删除优惠券模板
     *
     * @param ids 需要删除的优惠券模板主键
     * @return 结果
     */
    @Override
    public int deleteShopCouponTemplateByIds(Long[] ids)
    {
        return baseMapper.deleteShopCouponTemplateByIds(ids);
    }

    /**
     * 删除优惠券模板信息
     *
     * @param id 优惠券模板主键
     * @return 结果
     */
    @Override
    public int deleteShopCouponTemplateById(Long id)
    {
        return baseMapper.deleteShopCouponTemplateById(id);
    }

    @Override
    public IPage<ShopCouponTemplate> listCoupon(Page<ShopCouponTemplate> page,Long partnerId, String searchValue) {
        return baseMapper.listCoupon(page,partnerId,searchValue);
    }
}
